Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be available on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1197758 - pcs does not inform about incorrect command usage (pcs constraint order set)
Summary: pcs does not inform about incorrect command usage (pcs constraint order set)
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: pcs
Version: 7.1
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: rc
: ---
Assignee: Tomas Jelinek
QA Contact: cluster-qe@redhat.com
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-03-02 14:22 UTC by Miroslav Lisik
Modified: 2015-11-19 09:35 UTC (History)
3 users (show)

Fixed In Version: pcs-0.9.140-1.el7
Doc Type: Bug Fix
Doc Text:
Cause: User runs the 'pcs constraint colocation set' or the 'pcs constraint order set' command but does not specify any resources. Consequence: Pcs produces an invalid CIB and dumps it into a terminal. No constraint is created. Fix: Improve validation of the command's parameters. Result: User is informed about improper usage of the command and help for the command is displayed.
Clone Of:
Environment:
Last Closed: 2015-11-19 09:35:02 UTC
Target Upstream Version:


Attachments (Terms of Use)
proposed fix (26.75 KB, patch)
2015-05-26 15:45 UTC, Tomas Jelinek
no flags Details | Diff


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:2290 0 normal SHIPPED_LIVE Moderate: pcs security, bug fix, and enhancement update 2015-11-19 09:43:53 UTC

Description Miroslav Lisik 2015-03-02 14:22:01 UTC
Description of problem:

When i run command 'pcs constraint order set' without resource names then pcs ends with error:

Error: Unable to update cib
Call cib_replace failed (-203): Update does not conform to the configured schema
...
<long cib xml output truncated...>
...


Version-Release number of selected component (if applicable):

pcs-0.9.137-13.el7.x86_64

How reproducible:

always

Steps to Reproduce:

1. run command:
pcs constraint order set

Actual results:

Inappropriate error message about cib update and long stderr output with cib xml.

Expected results:

I'm expecting that pcs inform me about incorrect command usage.

Comment 2 Tomas Jelinek 2015-05-26 15:45:42 UTC
Created attachment 1030010 [details]
proposed fix

Comment 3 Tomas Jelinek 2015-06-04 14:44:57 UTC
Before Fix:
[root@rh71-node1 ~]# rpm -q pcs
pcs-0.9.137-13.el7_1.2.x86_64
[root@rh71-node1:~]# pcs constraint order set
Error: Unable to update cib
Call cib_replace failed (-203): Update does not conform to the configured schema
...



After Fix:
[root@rh71-node1:~]# rpm -q pcs
pcs-0.9.140-1.el6.x86_64
[root@rh71-node1:~]# pcs constraint order set

Usage: pcs constraint [constraints]...
    order set <resource1> <resource2> [resourceN]... [options] [set
...

Comment 5 Miroslav Lisik 2015-07-14 17:44:00 UTC
Marking VERIFIED in pcs-0.9.142-2.el7.x86_64

BEFORE FIX:

[root@virt-076 ~]# rpm -q pcs
pcs-0.9.137-13.el7.x86_64

[root@virt-076 ~]# pcs constraint order set 
Error: Unable to update cib
Call cib_replace failed (-203): Update does not conform to the configured schema
...


AFTER FIX:

[root@virt-076 yum.repos.d]# rpm -q pcs
pcs-0.9.142-2.el7.x86_64

[root@virt-076 ~]# pcs constraint order set 

Usage: pcs constraint [constraints]...
    order set <resource1> <resource2> [resourceN]... [options] [set
              <resourceX> <resourceY> ... [options]]
              [setoptions [constraint_options]]
        Create an ordered set of resources.
        Available options are sequential=true/false, require-all=true/false,
        action=start/promote/demote/stop and role=Stopped/Started/Master/Slave.
        Available constraint_options are id=<constraint-id>,
        kind=Optional/Mandatory/Serialize and symmetrical=true/false.

[root@virt-076 ~]# echo $?
1

Bad command usage was recognized and user was informed about pcs usage.

Comment 7 errata-xmlrpc 2015-11-19 09:35:02 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-2290.html


Note You need to log in before you can comment on or make changes to this bug.